UNIT Globals;
{ͻ}
{ Global declarations                           Last changed: 02.03.97  SA }
{                                                                          }
{                         (C) Copyright 1989-97 by                         }
{       Dan Wulff, Jens Sandalgaard, Steen Christensen & Sren Ager        }
{                                                                          }
{ This source may not be given to anybody, without the written permission  }
{ from The Portal Team.                                                    }
{ͼ}
{$I POPDEFS.INC}

INTERFACE

USES Use32, Dos, OpWindow, OpString,
     OpDate, OpRoot, OpField, ApTimer,
     PoPTypes, OproUtil, Com;

CONST
  MaxAreas       = 500;
  StatusStr      : STRING[9] = '';
  Topic          : Word = 0;
  CmdLineFlags   : Word = 0;             { See cl* in POPTYPES.PAS }
  DoConfig       : Byte = 0;
  KeyboardLock   : Boolean = False;
  ScreenBlanked  : Boolean = False;
  GotSomeMail    : Boolean = False;
  GotSomeFiles   : Boolean = False;

  MainMenu       : PPoPMenu = NIL;
  NodesIdx       : Pointer = NIL;
  ComPort        : PAbsCom = NIL;

TYPE
  POutList = ^TOutList;
  TOutList = OBJECT(DoubleListNode)
    Address        : TFidoAddress;
    Size           : LongInt;
    Bits           : Byte;
    Baud           : Word;
    Closed,
    Known,
    NoCMail,
    DontCall,
    Glued          : Boolean;
    FilesToSend    : Word;
    Age            : Integer;
    OpenFrom,
    OpenTo         : Time;
    NC,
    BWZ,
    Cost           : Word;

    Constructor Init;
  END;

  AreaRec = RECORD
    Tag,
    Title,
    Path,
    FPath : StringPtr;
  END;
  AreaTab    = Array[1..MaxAreas] OF ^AreaRec;
  AreaTabPtr = ^AreaTab;

  TMemUsage = (mu_Upper, mu_EMS, mu_XMS);
  TMemUsageSet = SET OF TMemUsage;

VAR
  SynchTimeDiff                           : LongInt;
  MemUsage                                : TMemUsageSet;
  RspFile, StartPath                      : PathStr;
  FoundInNl, FoundInNodes, ConfigChanged,
  IsCaller, RequestSent,
{$IFNDEF OS2}
  SaveBreakState,
{$ENDIF}
  FullDuplex, MailToSend, InLogWin        : Boolean;
  IntroWin, Outboundwindow,
  ActivityWindow, StatusWindow,
  CallsIn, CallsOut                       : WindowPtr;
  Cfg                                     : TConfig;
  Data                                    : TDataFile;
  FSent, FReceived                        : Word;
  Call                                    : TFidoAddress;
  OutList                                 : DoubleListPtr;
  FLOutListPtr, CLOutListPtr              : POutList;
  ModemReInit, OutboundReRead, ScreenBlank: EventTimer;
  GlobNodeStat                            : TNodeStat;
  UserHook, olderrptr                     : Pointer;
  TmpPassword                             : S20;
  FwdSysOpName                            : S35;
  NodesRec                                : TNodeInfo;
  RemAka                                  : Array[1..MaxAddresses] Of TFidoAddress;
{$IFNDEF OS2}
  ExecDSwap : FUNCTION(Cmd: STRING; UseSecond: Boolean; EDP: Pointer; SwapFName: PathStr): Integer;
{$ENDIF}
{$IFNDEF PMode}
  I16, R16                                : Procedure;
{$ENDIF}
  CurrentLogView, EndLogView              : Array[1..MaxActivityLines] of LongInt;
  CurrentEvent                            : TEvent;
  StatRec                                 : PPortalStat;

  MaxReqFiles : Word;
  MaxReqTime  : Time;
  MaxReqBytes : LongInt;
  DRI         : TDailyReqInfo;

IMPLEMENTATION

  CONSTRUCTOR TOutList.Init;
  BEGIN
    IF Not DoubleListNode.Init THEN Fail;
    Address.Zone:=0; Address.Net:=0; Address.Node:=0; Address.Point:=0;
    Size:=0; Bits:=0; Baud:=0;
    Known:=False; Closed:=False; NoCMail:=True; DontCall:=False; Glued:=False;
    FilesToSend:=0; Age:=0; Cost:=0;
  END;

END.
